01000  ! CustRept.br    #Autonumber# 1000,10
01010  !
01020  ! Created 3/30/2010
01030  ! by Gabriel Bakker
01040  !
01050  ! Sample Library using FileIO to build a simple Customer Report.
01060  !
01070  ! Main Program should only call main function and then stop.
01080  ! so if you run this library as a program it still works.
01090  !
01100     library : fnPrintReport
01110     let fnPrintReport
01120     stop
01130  !
10000  ! .! #Autonumber# 10000,10
10010     def library fnPrintReport
10020  !
10030  ! .   ! Step 1: Establish Library Linkage to FileIO
10040        library "fileio" : FnOpenFile
10050  !
10060  ! .   ! Step 2: Declare File Object Variables, and Forms Array.
10070        dim Customer$(1)*255,Customer(1)
10080        dim Form$(1)*255
10090  !
10100  ! .   ! Step 3: Open Data File
10110        let CustomerFile=fnOpen("customer",mat Customer$,mat Customer,mat Form$,1)
10120  !
10130  ! .   ! Also open the printer for printing a report, and print a heading
10140        open #255: "name=preview:/, recl=500",display,output
10150        print #255, using ReportFormSkip0 : "Customer Name","City","Zip","Phone"
10160        print #255, using ReportForm : "______________________________","______________________________","_____","____________"
10170  !
10180  ! .   ! Step 4: Read the Data File in a loop
10190        do while file(CustomerFile)=0
10200           read #CustomerFile, using form$(CustomerFile) : mat Customer$, mat Customer eof Ignore
10210  ! .      ! Print the record
10220           let Customer$(cu_phone)="("&Customer$(cu_phone)(1:3)&")"&Customer$(cu_phone)(4:6)&"-"&Customer$(cu_phone)(7:10)
10230           print #255, using ReportForm : Customer$(cu_name), Customer$(cu_City), Customer$(cu_zip),Customer$(cu_phone)
10240        loop
10250  !
10260        ReportFormSkip0: form C 30, C 30, C 7, C 13, Skip 0
10270        ReportForm: form C 30, C 30, C 7, C 13
10280  !
10290  ! .   ! Step 5: Close the Datafile, end the program
10300        close #CustomerFile:
10310     fnend
10320  !
10330  ! Step 6: Copy and paste standard FileIO Open Function.
99000  ! #Autonumber# 99000,10
99010  OPEN: ! ***** Function To Call Library Openfile And Proc Subs
99020     def Fnopen(Filename$*255, Mat F$, Mat F, Mat Form$; Inputonly, Keynum, Dont_Sort_Subs, Path$*255, Mat Descr$, Mat Field_Widths,___,Index)
99030        dim _FileIOSubs$(1)*800
99040        let Fnopen=Fnopenfile(Filename$, Mat F$, Mat F, Mat Form$, Inputonly, Keynum, Dont_Sort_Subs, Path$, Mat Descr$, Mat Field_Widths, Mat _FileIOSubs$)
99050        for Index=1 to udim(mat _FileIOSubs$) : execute (_FileIOSubs$(Index)) : next Index
99060     fnend
99070  !
99900  ! #Autonumber# 99900,10
99910  IGNORE: continue
